-- GSI - general sound interface
-- sound.e
--
-- Copyright (C) W.H.Scholten 1996,1997,1998
--
-- ** See gsi.h for a description of the commands **
--
-- License: CGPL (see the file LICENSE.CGPL)
--

class GSI_INTERFACE
   --Note that this was based on SND_SERVER 0.47 and must be updated for 
   --GSI (and it must be completed)

inherit
   LIBC

--char *mixerdev=MIXERDEV;
--static int  soundfd;
--static char sndserver_ok = 1;
--static char mixer_ok = 1;
--
--int  sound_volume=4;
--int  sound_on=1;

   num_commands: INTEGER
   sound_command: ARRAY[CHARACTER]

   MAX_QUEUE_LENGTH : INTEGER is 256

--/*__________________DATA___________________*/
--int volume_table[16]={
--#ifdef LOG_VOLUME
--    0,30,45,55,67,70,73,76,79,82,85,88,91,94,97,100
--#endif
--#ifdef LINEAR_VOLUME
--    0,7,13,20,27,33,40,47,53,60,67,73,80,87,93,100
--#endif
--};


feature
   volume_table: ARRAY[INTEGER] is <<  0,30,45,55,67,70,73,76,79,82,85,88,91,94,97,100 >>

   child_killed(i: INTEGER) is
      do
debugmsg("child killed, no ", i)
	 sndserver_ok:=0
	 io.put_string("sound server killed%N")
      end

   gsi_init: INTEGER is
      do
	 !!send_command(0, MAX_QUEUE_LENGTH)
      end


   -- Set the sound volume
   -- MIXER VOLUME SETTINGS:
   --    SPEAKER: speaker directly connected to sound card (not GUS)
   --    VOLUME : MASTER volume, i.e. headphone and line out.
   --    PCM    : dsp level
   --    ALTPCM : dsp for ASP16
   --
   volume: INTEGER

   set_volume(vol: INTEGER) is
      local
	 mixer: INTEGER
      do
	 if mixer_ok then
	    mixer:= open(mixerdev, O_WRONLY + O_NONBLOCK)
	    volume:= volume_table @ sound_volume
	    volume:= volume + volume @<< 8 -- LEFT AND RIGHT CHANNEL >>
	    ioctl(mixer, SOUND_MIXER_WRITE_PCM, $volume)
	    close(mixer)
	 end
      end


   gsi_init_pcm(dsp_speed, dsp_channels, dsp_bytes, dsp_fragsize: INTEGER; sounddir: STRING; soundfile: STRING) is
      local
	 sndserver_filename: POINTER
      do
--    int  child, fd[2];
--    char *argv[3];
--    char *sndserver_filename;

	 !!sound_commands.make(0,255)

	 sndserver_filename:=getenv("DSPSERVER")

--    if (!(sndserver_filename=getenv("DSPSERVER"))) sndserver_filename=BINDIR"/"SOUNDSERVER;
	 if sndserver_filename=NULL then sndserver_filename:=(BINDIR+"/"+SOUNDSERVER).to_external end
--//    strcpy(sndserver_filename, BINDIR"/"SOUNDSERVER);
	 
	 signal(SIGCHLD, $child_killed)

--    // Create a pipe, set the write end to close when we exec the sound server,
--    // and set both ends to non-blocking (in the server)
--    //for feedback:
--    // pipe(fd2);
--    // soundfd2=fd2[0];
--
	 pipe(fd)
    soundfd:=fd @ 1
--
--    if( !(child=fork()) )  {
--	/* child's thread */
--	close(fd[1]);
--	dup2(fd[0], STDIN_FILENO);
--	close(fd[0]);
--	// close(fd2[0]);
--	// dup2(fd2[1], STDOUT_FILENO);
--	// close(fd2[1]);
--
--	argv[0] = sndserver_filename;
--	argv[1] = "-loop";
--	argv[2] = NULL;
--	execvp(sndserver_filename, argv);
--	fprintf (stderr, "Couldn't execute %s!\n", sndserver_filename);
--	exit (0);
--    }
--
--    close(fd[0]);
--    // close(fd2[1]);
--
--    DEB1(printf("sndserver_ok=%d\n", sndserver_ok));




	 if sndserver_ok then
--	//server starts PAUSE'd, DSP released.
	    send_byte(SND_SET_DSP_SPEED);   send_int16(dsp_speed);
--	DEB1(printf("SND: set speed %d\n", dsp_speed));
	    send_byte(SND_SET_CHANNELS);    send_byte(dsp_channels);
--	DEB1(printf("SND: set chan  %d\n", dsp_channels));
	    send_byte(SND_SET_BYTES);       send_byte(dsp_bytes);
--	DEB1(printf("SND: set bytes %d\n", dsp_bytes));
	    send_byte(SND_SET_FRAGSIZE);    send_byte(dsp_fragsize);
--	DEB1(printf("SND: set frag  %d\n", dsp_fragsize));
	    send_byte(SND_SET_SOUND_DIR);   send_string(sounddir);
--	DEB1(printf("SND: set sounddir  %s\n", sounddir));
	    send_byte(SND_LOAD_SOUND_LIST); send_string(soundfile);
--	DEB1(printf("SND: set soundsfile  %s\n", soundfile));
	    send_byte(SND_LOAD_LISTED);
--	DEB1(printf("SND: SND_LOAD_LISTED\n"));
	    send_byte(SND_GRAB_DSP); --This sets the new parameters.
--	DEB1(printf("SND: SND_GRAB_DSP\n"));
	 end

--    int mixer, value;

	 mixer:=open(mixerdev, O_WRONLY + O_NONBLOCK)

	 if mixer=-1 then
	    mixer_ok:=0
	    io.put_string("sound: Couldn't open mixer%N")
	 else
	    value:=SET_MV + SET_MV*256

	    ioctl(mixer, SOUND_MIXER_WRITE_VOLUME, $value) --set master volume
	    set_volume(sound_volume)
	    close(mixer)
	 end
	 io.put_string("Sound server initialized.%N")
      end


   gsi_kill_sounds is
      do
	 num_commands:=0
	 send_byte(SND_KILLALL)
      end


   -- Send any command string:
   gsi_send_commands(list: ARRAY[INTEGER]) is
      local
	 i: INTEGER
      do
	 from i:=1 until i>list.size loop
	    sound_command.put(list.item(i), num_commands)
	    num_commands :=num_commands+1
	    if num_commands=MAX_QUEUE_LENGTH then gsi_flush end
	    i:=i+1
	 end
      end

   gsi_play_stereo_sound (slot, command, x, dx: INTEGER) is
      do
	 if sound_on and sndserver_ok then
	    general_sound(<<command, slot, SND_SET_X + SND_CURRENT, (x.to_bit and 255).to_integer, (x.to_bit @>>8).to_integer, SND_SET_DX + SND_CURRENT, dx>>)
	 end
      end

   gsi_play_sound (slot, command: INTEGER) is
      do
	 if sound_on and sndserver_ok then
	    if num_commands==MAX_QUEUE_LENGTH-1 then gsi_flush end
	    sound_command.put(command, num_commands)
	    num_commands:=num_commands+1
	    sound_command.put(slot, num_commands)
	    num_commands:=num_commands+1
	    debug
	       io.put_string("play sound (snd ") io.put_integer(k)
	       io.put_string(", com ") io.put_integer(command)
	       io.put_string(", num commands now ") io.put_integer(num_commands)
	       io.put_new_line
	    end
	 end
      end


   gsi_play_channel_sound (channel, slot, command: INTEGER) is
      do
	 if sound_on and sndserver_ok then
	    if num_commands==MAX_QUEUE_LENGTH-2 then gsi_flush end
	    sound_command.put(command + SND_CHANNEL, num_commands)
	    num_commands:=num_commands+1
	    sound_command.put(channel, num_commands)
	    num_commands:=num_commands+1
	    sound_command.put(slot, num_commands)
	    num_commands:=num_commands+1
	 end
      end

   gsi_close_pcm() is
      do
	 release_sound
	 if sndserver_ok then
	    send_byte(SND_CLOSE_SERVER)
	 end
	 sndserver_ok:=False
      end

   gsi_flush is
      local
	 i: INTEGER
      do
	 from i:=0 until i=num_commands loop
	    send_byte(sound_command @ i)
	 end
	 num_commands:=0
      end

   gsi_play_sound_flush (slot, command: INTEGER) is
      do
	 gsi_play_sound (slot, command)
	 gsi_flush()
      end

   gsi_pause_sound() is
      do
	 if sndserver_ok then send_byte(SND_PAUSE_ALL) end
      end

   gsi_continue_sound is
      do
	 if sndserver_ok then send_byte(SND_CONTINUE_ALL) end
      end

   gsi_grab_pcm is
      do
	 if sndserver_ok then send_byte(SND_GRAB_DSP) end
      end

   gsi_release_pcm is
      do
	 if sndserver_ok then send_byte(SND_RELEASE_DSP) end
      end


   -- + -------------------------------------------------------- +
   --Pipe functions
   pipe_byte: CHARACTER

   send_byte(data: BIT 32) is
      do
	 pipe_byte:=data and 255
	 debugmsg("sound byte: sending ", pipe_byte)
	 if sndserver_ok then write (soundfd, &pipe_byte, sizeof (byte)) end
      end

   send_int16(data: BIT 32) is
      do
	 if sndserver_ok then
	    send_byte(data)
	    send_byte(data @>>8)
	 end
      end

   send_int32(data: BIT 32) is
      local
      do
	 if sndserver_ok then
	    send_byte(data)
	    send_byte(data @>>8)
	    send_byte(data @>>16)
	    send_byte(data @>>24)
	 end
      end

   send_string(s: STRING) is
--      local
--	 n: INTEGER
      do
	 if sndserver_ok then
	    if s=Void or else s.size=0 then
	       send_byte(0)
	    else
--	    n:=write (soundfd, s.to_external, s.length)
	       send_block(s.to_external, s.size)
--	       debugmsg("sound string: no bytes = ", n)
	 end
      end

   gsi_send_block(data: POINTER; len: INTEGER) is
      local
	 write_fd_sel: FD_SET
	 i, j: INTEGER
      do
	 i:=0
	 j:=0
--	DEB1(prt("SNDI: _gsi_send_block: sending a block of %d bytes\n", len))
	if sndserver_ok then
	   from until i=len loop
	      j:=write (soundfd, data+i, len-i))
	      if (j>0) then i =i+j end
--			FD_ZERO($write_fd_sel)
--			fd_FD_SET(soundfd, $write_fd_sel)
	      write_fd_sel.FD_ZERO
	      write_fd_sel.FD_SET(soundfd)
--			select(soundfd+1, NULL, $write_fd_sel, NULL, NULL)
	      fd_select(soundfd+1, NULL, write_fd_sel.data, NULL, NULL)
	   end
	end
     end
end
